<?php 
class ControllerPaymentCCAvenue extends Controller {
	private $error = array(); 

	public function index() {
		$this->load->language('payment/ccavenue');

		$this->document->title = $this->language->get('heading_title');
		
		$this->load->model('setting/setting');
			
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
			$this->load->model('setting/setting');
			
			$this->model_setting_setting->editSetting('ccavenue', $this->request->post);				
			
			$this->session->data['success'] = $this->language->get('text_success');

			$this->redirect($this->url->https('extension/payment'));
		}

		$this->data['heading_title'] = $this->language->get('heading_title');

		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_all_zones'] = $this->language->get('text_all_zones');
		$this->data['text_none'] = $this->language->get('text_none');
		$this->data['text_american'] = $this->language->get('text_american');
		$this->data['text_indian'] = $this->language->get('text_indian');
		
		$this->data['entry_key'] = $this->language->get('entry_key');
		$this->data['entry_merchant'] = $this->language->get('entry_merchant');
		$this->data['entry_gateway'] = $this->language->get('entry_gateway');
		$this->data['entry_order_status'] = $this->language->get('entry_order_status');		
		$this->data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');
		
		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');

		$this->data['tab_general'] = $this->language->get('tab_general');

		$this->data['error_warning'] = @$this->error['warning'];
		$this->data['error_key'] = @$this->error['key'];
		$this->data['error_merchant'] = @$this->error['merchant'];

  		$this->document->breadcrumbs = array();

   		$this->document->breadcrumbs[] = array(
       		'href'      => $this->url->https('common/home'),
       		'text'      => $this->language->get('text_home'),
      		'separator' => FALSE
   		);

   		$this->document->breadcrumbs[] = array(
       		'href'      => $this->url->https('extension/payment'),
       		'text'      => $this->language->get('text_payment'),
      		'separator' => ' :: '
   		);

   		$this->document->breadcrumbs[] = array(
       		'href'      => $this->url->https('payment/ccavenue'),
       		'text'      => $this->language->get('heading_title'),
      		'separator' => ' :: '
   		);
				
		$this->data['action'] = $this->url->https('payment/ccavenue');
		
		$this->data['cancel'] = $this->url->https('extension/payment');
		
		if (isset($this->request->post['ccavenue_key'])) {
			$this->data['ccavenue_key'] = $this->request->post['ccavenue_key'];
		} else {
			$this->data['ccavenue_key'] = $this->config->get('ccavenue_key');
		}
		
		if (isset($this->request->post['ccavenue_merchant'])) {
			$this->data['ccavenue_merchant'] = $this->request->post['ccavenue_merchant'];
		} else {
			$this->data['ccavenue_merchant'] = $this->config->get('ccavenue_merchant');
		}

		if (isset($this->request->post['ccavenue_gateway'])) {
			$this->data['ccavenue_gateway'] = $this->request->post['ccavenue_gateway'];
		} else {
			$this->data['ccavenue_gateway'] = $this->config->get('ccavenue_gateway');
		}
		
		if (isset($this->request->post['ccavenue_order_status_id'])) {
			$this->data['ccavenue_order_status_id'] = $this->request->post['ccavenue_order_status_id'];
		} else {
			$this->data['ccavenue_order_status_id'] = $this->config->get('ccavenue_order_status_id'); 
		} 

		$this->load->model('localisation/order_status');
		
		$this->data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
		
		if (isset($this->request->post['ccavenue_geo_zone_id'])) {
			$this->data['ccavenue_geo_zone_id'] = $this->request->post['ccavenue_geo_zone_id'];
		} else {
			$this->data['ccavenue_geo_zone_id'] = $this->config->get('ccavenue_geo_zone_id'); 
		} 
		
		$this->load->model('localisation/geo_zone');
										
		$this->data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();
		
		if (isset($this->request->post['ccavenue_status'])) {
			$this->data['ccavenue_status'] = $this->request->post['ccavenue_status'];
		} else {
			$this->data['ccavenue_status'] = $this->config->get('ccavenue_status');
		}
		
		if (isset($this->request->post['ccavenue_sort_order'])) {
			$this->data['ccavenue_sort_order'] = $this->request->post['ccavenue_sort_order'];
		} else {
			$this->data['ccavenue_sort_order'] = $this->config->get('ccavenue_sort_order');
		}
		
		$this->id       = 'content';
		$this->template = 'payment/ccavenue.tpl';
		$this->layout   = 'common/layout';
		
 		$this->render();
	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'payment/ccavenue')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		if (!@$this->request->post['ccavenue_key']) {
			$this->error['key'] = $this->language->get('error_key');
		}

		if (!@$this->request->post['ccavenue_merchant']) {
			$this->error['merchant'] = $this->language->get('error_merchant');
		}
		
		if (!$this->error) {
			return TRUE;
		} else {
			return FALSE;
		}	
	}
}
?>